<?php
/**
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; under version 2
 * of the License (non-upgradable).
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * Copyright (c) 2008-2010 (original work) Deutsche Institut für Internationale Pädagogische Forschung (under the project TAO-TRANSFER);
 *               2009-2012 (update and modification) Public Research Centre Henri Tudor (under the project TAO-SUSTAIN & TAO-DEV);
 *
 */

/**
 * Short description of class tao_helpers_form_validators_Password
 *
 * @access public
 * @author Joel Bout, <joel.bout@tudor.lu>
 * @package tao

 */
class tao_helpers_form_validators_Password extends tao_helpers_form_Validator
{
    // --- ASSOCIATIONS ---


    // --- ATTRIBUTES ---

    // --- OPERATIONS ---

    /**
     * Short description of method evaluate
     *
     * @access public
     * @author Joel Bout, <joel.bout@tudor.lu>
     * @param  values
     * @return boolean
     */
    public function evaluate($values)
    {
        $returnValue = (bool) false;


        if (is_array($values) && count($values) == 2) {
            list($first, $second) = $values;
            $returnValue = $first == $second;
        } elseif ($this->hasOption('password2_ref')) {
            $secondElement = $this->getOption('password2_ref');
            if (is_null($secondElement) || ! $secondElement instanceof tao_helpers_form_FormElement) {
                throw new common_Exception("Please set the reference of the second password element");
            }
            if ($values == $secondElement->getRawValue() && trim($values) != '') {
                $returnValue = true;
            }
        } else {
            throw new common_Exception("Please set the reference of the second password element or provide array of 2 elements");
        }



        return (bool) $returnValue;
    }

    protected function getDefaultMessage()
    {
        return __('Passwords are not matching');
    }
}
