<?php

declare(strict_types=1);

namespace oat\tao\migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\Exception\IrreversibleMigration;
use oat\tao\scripts\SyncModels;
use oat\tao\scripts\tools\migrations\AbstractMigration;

final class Version202207041535182168_tao extends AbstractMigration
{
    public function getDescription(): string
    {
        return 'Update Ontology models';
    }

    public function up(Schema $schema): void
    {
        $this->runAction(new SyncModels());
    }

    public function down(Schema $schema): void
    {
        throw new IrreversibleMigration(
            'The models should be updated via `SyncModels` script after reverting their RDF definitions.'
        );
    }
}
