<?php
/**
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; under version 2
 * of the License (non-upgradable).
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * Copyright (c) 2013 (original work) Open Assessment Technologies SA (under the project TAO-PRODUCT);
 *
 */

/**
 * Exception to be thrown when an error occurs at compilation time.
 *
 * @access public
 * @author Joel Bout, <joel@taotesting.com>
 * @package tao

 */
class tao_models_classes_CompilationFailedException extends common_Exception
{
    
    /**
     * Create a new CompilationFailedException object.
     *
     * @param string $message A human-readable message describing the compilation error.
     * @param integer $code A computer-understandable code describing the compilation error.
     */
    public function __construct($message, $code = 0)
    {
        parent::__construct($message, $code);
    }
}
